
################## IRENE SALVADOR ORTEGA

# Resultados finales. Captulo de la seleccin de caractersticas considerando todos los usuarios juntos

## Pasos a llevar a cabo:
#   -Dividir los datos en train y test segn las necesidades de cada caso
#   -El conjunto de test tiene que contener los AUTNTICOS y los IMPOSTORES (que puede ser cualquier conjunto con el que contrastar)
#   -Obtener SCORE del conjunto de train con TEST AUTNTICOS y otros SCORES del conjunto de train
#con TEST IMPOSTORES.
#   -Utilizar 1-vecinos ms prximos (K=1) con el rendimiento final elegido de aplicar varias ventanas (4p2solap MEDIANA) a tamaos de ventana entre 6 y 10 y el estadstico fusin de la media
#   -Obtener la tasa de equierror (EER) para comparar
#   -Ir variando el nmero de caracteristicas usadas -> de 1 en 1 hasta el maximo (mximo desconocido pero inferior a 13 en todos los casos) 
#   -Usuarios disponibles: 1,2,3,5,8,9,10,11,12,13,14,15,17,18

#Se obtendrn 8 tablas en: DT_X, DT_Y, DT_Z, modulo_DT, DF_X, DF_Y, DF_Z, modulo_DF

#Lbrerias necesarias
library(FNN)  #para aplicar el clasificador (k-vecinos ms prximos)
library("PRROC")  #para la construccin de la curva ROC
#Para la obtencin de la tasa de equierror (EER)
#Libreria instalada desde github
#install.packages("devtools")
library(devtools)
#install_github("davidavdav/ROC")
library("ROC")
#para el grfico de los vecinos ms prximos, variando el valor de k
#install.packages("ggplot2")
#install.packages("ggplot2")
library(ggplot2)
library(reshape2)

### FUNCIN PRINCIPAL
# Guarda los resultados en formato CSV, donde para cada usuario y para cada posibilidad de nmero de caractersticas 
# aplica el sistema de reconocimiento final construido y guarda el valor de la mtrica considera: EER

obtener_tabla_VariarNCaracteristicas<-function(umbral,ruta_inicio_auxiliar, dominio, experimental, k_knn, dispositivo, tipo, extension_ventana_EC, solapamiento, inicioScores, finScores, numVentanas, solapamientoVent, est_scores){
  
  ##### PASO 1) Lectura de la tabla que contiene las caractersticas ms importantes en orden
  ruta_inicio<-paste(ruta_inicio_auxiliar,"SeleccionCaracter/",dispositivo,tipo,"/",experimental,"/",dominio,"/umbralVariable",sep="")
  setwd(ruta_inicio)
  orden_caract<-read.csv2(file=paste(ruta_inicio,"/ordenCaract_",dominio,"_umbral_",umbral,"_RELIEF.txt",sep=""), header=FALSE)
  orden_caract<-as.character(orden_caract$V1)
  
  if(experimental=="MonoMono"){
    usuarios_utilizar<-c(1,2,3,5,8,9,10,11,12,13,14,15,17,18)
  }
  
  n_caract_maximo<-length(orden_caract)
  n_caracteristicas<-seq(1,n_caract_maximo,by=1)
  
  tabla_final_EER<-data.frame(NULL, NULL, NULL)
  
  #--> Me sirve para cuando elimino las ventanas con baja autocorrelacin, en funcin de donde estoy, que atributo seleccionar
  if(dominio=="DT_X" || dominio=="DF_X"){
    variable<-"Autocorr_X"
  }else if(dominio=="DT_Y" || dominio=="DF_Y"){
    variable<-"Autocorr_Y"
  }else if(dominio=="DT_Z" || dominio=="DF_Z"){
    variable<-"Autocorr_Z"
  }else if(dominio=="modulo_DT" || dominio=="modulo_DF"){
    variable<-"Autocorr"
  }
  
  if(dominio=="DT_X" || dominio=="DT_Y" || dominio=="DT_Z" || dominio=="modulo_DT"){
    preprocesamiento<-"datos_MM3_originales"
  }else if(dominio=="DF_X" || dominio=="DF_Y" || dominio=="DF_Z" || dominio=="modulo_DF"){
    preprocesamiento<-"datos_interpolados"
  }
  
  for(user in usuarios_utilizar){    #para cada usuario
    for(k in n_caracteristicas){   #para cada cantidad de caracteristicas
      caract_usar<-orden_caract[1:k]
      
      scores_aut_usuario_rendimiento<-data.frame(NULL,NULL)
      scores_imp_usuario_rendimiento<-data.frame(NULL,NULL)
      for(extension_ventana in inicioScores:finScores){
        ## -> lectura de la tabla de caractersticas...
        if(dominio=="DT_X" || dominio=="DT_Y" || dominio=="DT_Z" || dominio=="DF_X" || dominio=="DF_Y" || dominio=="DF_Z"){
          tabla_datos<-read.csv2(paste(ruta_inicio_auxiliar,dispositivo,tipo,"/tablas_caract/",preprocesamiento,"/",dispositivo,"_",tipo,"_",extension_ventana,"veces_",solapamiento,"%solap_XYZ.csv",sep=""), header=TRUE, sep=";")
        }else if(dominio=="modulo_DT" || dominio=="modulo_DF"){
          tabla_datos<-read.csv2(paste(ruta_inicio_auxiliar,dispositivo,tipo,"/tablas_caract/",preprocesamiento,"/",dispositivo,"_",tipo,"_",extension_ventana,"veces_",solapamiento,"%solap_modulo.csv",sep=""), header=TRUE, sep=";")
        }
        
        #Eliminar autocorrelacin <3/4
        tabla_final<-data.frame(NULL,NULL,NULL)
        for(user_ren in 1:20){
          for(sesion_ren in 1:2){
            for(muestra_ren in 1:2){
              eval(parse(text = paste("autocorr_USM<-tabla_datos[tabla_datos[,\"usuario\"]==\"usuario",user_ren,"\" & tabla_datos[,\"sesion\"]==\"S",sesion_ren,"\" & tabla_datos[,\"muestra\"]==\"M",muestra_ren,"\",\"",variable,"\"]", sep = "")))
              
              valor<-(max(abs(autocorr_USM))*3)/4
              no_eliminadas<-autocorr_USM[abs(autocorr_USM)>=valor]
              
              limite_autocorrelacion<-0.75
              while( length(no_eliminadas)<numVentanas+solapamientoVent & length(autocorr_USM) != 0 & limite_autocorrelacion>=0){
                limite_autocorrelacion<-limite_autocorrelacion-0.05
                valor<-max(abs(autocorr_USM))*(limite_autocorrelacion)
                no_eliminadas<-autocorr_USM[abs(autocorr_USM)>=valor]
                #cat("Cambiando el lmite de la autocorrelacin:",limite_autocorrelacion,",usuario:",user_ren,",sesion:",sesion_ren,",muestra",muestra_ren,"\n")
              }
              
              eval(parse(text = paste("seleccionadas<-tabla_datos[tabla_datos[,\"usuario\"]==\"usuario",user_ren,"\" & tabla_datos[,\"sesion\"]==\"S",sesion_ren,"\" & tabla_datos[,\"muestra\"]==\"M",muestra_ren,"\" & abs(tabla_datos[,\"",variable,"\"])>=valor, ]", sep = "")))
              tabla_final<-rbind(tabla_final, seleccionadas)
            }
          }
        }
        
        tabla_final<-tabla_final[,names(tabla_final) %in% c("usuario","sesion","muestra",as.character(caract_usar))]
        
        tabla<-"tabla_final"
        
        if(experimental=="MonoMono"){
          train<-eval(parse(text = paste(tabla,"[",tabla,"[,\"sesion\"]==\"S1\" & ",tabla, "[,\"muestra\"]==\"M1\" &",tabla, "[,\"usuario\"]==\"usuario", user,"\",]", sep = "")))
          test_autenticos<-eval(parse(text = paste(tabla,"[",tabla,"[,\"sesion\"]==\"S1\" & ",tabla, "[,\"muestra\"]==\"M2\" &",tabla, "[,\"usuario\"]==\"usuario", user,"\",]", sep = "")))
          test_impostores<-eval(parse(text = paste(tabla,"[",tabla,"[,\"sesion\"]==\"S1\" & ",tabla, "[,\"muestra\"]==\"M2\" &",tabla, "[,\"usuario\"]!=\"usuario", user,"\",]", sep = "")))
        }else if(experimental=="MultiMono"){
          train<-eval(parse(text = paste(tabla,"[",tabla,"[,\"sesion\"]==\"S1\" & ",tabla, "[,\"muestra\"]==\"M1\" &",tabla, "[,\"usuario\"]==\"usuario", user,"\",]", sep = "")))
          test_autenticos<-eval(parse(text = paste(tabla,"[",tabla,"[,\"sesion\"]==\"S2\" & ",tabla, "[,\"muestra\"]==\"M1\" &",tabla, "[,\"usuario\"]==\"usuario", user,"\",]", sep = "")))
          test_impostores<-eval(parse(text = paste(tabla,"[",tabla,"[,\"sesion\"]==\"S1\" & ",tabla, "[,\"muestra\"]==\"M2\" &",tabla, "[,\"usuario\"]!=\"usuario", user,"\",]", sep = "")))
        }else if(experimental=="MultiMulti"){
          train<-eval(parse(text = paste(tabla,"[",tabla, "[,\"muestra\"]==\"M1\" &",tabla, "[,\"usuario\"]==\"usuario", user,"\",]", sep = "")))
          test_autenticos<-eval(parse(text = paste(tabla,"[",tabla, "[,\"muestra\"]==\"M2\" &",tabla, "[,\"usuario\"]==\"usuario", user,"\",]", sep = "")))
          test_impostores<-eval(parse(text = paste(tabla,"[",tabla, "[,\"muestra\"]==\"M2\" &",tabla, "[,\"usuario\"]!=\"usuario", user,"\",]", sep = "")))
        }
        
        if(dim(train)[1]>0 & dim(test_autenticos)[1]>0 & dim(test_impostores)[1]>0 & floor((dim(test_autenticos)[1]-numVentanas)/solapamientoVent)+1>0 & floor((dim(test_impostores)[1]-numVentanas)/solapamientoVent)+1>0){
          
          train_limpio<-train[,!(names(train) %in% c("usuario","sesion","muestra"))]
          test_autenticos_limpio<-test_autenticos[,!(names(test_autenticos) %in% c("usuario","sesion","muestra"))]
          test_impostores_limpio<-test_impostores[,!(names(test_impostores) %in% c("usuario","sesion","muestra"))]
          
          fit_autenticos<-knnx.dist(data=train_limpio, 
                                    query=test_autenticos_limpio, k=k_knn, algorithm="brute")
          fit_impostores<-knnx.dist(data=train_limpio, 
                                    query=test_impostores_limpio, k=k_knn, algorithm="brute")
          
          fit_autenticos<-fit_autenticos[,ncol(fit_autenticos)]
          fit_impostores<-fit_impostores[,ncol(fit_impostores)]
          
          fit_autenticos_nueva<-vector()
          indice_autenticos<-1
          while(indice_autenticos+numVentanas-1<=length(fit_autenticos)){
            seleccion<-fit_autenticos[indice_autenticos:(indice_autenticos+numVentanas-1)]
            medida<-median(seleccion)
            fit_autenticos_nueva<-c(fit_autenticos_nueva, medida)
            indice_autenticos<-indice_autenticos+solapamientoVent
          }
          
          fit_impostores_nueva<-vector()
          indice_impostores<-1
          while(indice_impostores+numVentanas-1<=length(fit_impostores)){
            seleccion<-fit_impostores[indice_impostores:(indice_impostores+numVentanas-1)]
            medida<-median(seleccion)
            fit_impostores_nueva<-c(fit_impostores_nueva, medida)
            indice_impostores<-indice_impostores+solapamientoVent
          }
          
          scores_aut_usuario_rendimiento[1:length(fit_autenticos_nueva),extension_ventana-inicioScores+1]<-fit_autenticos_nueva
          scores_imp_usuario_rendimiento[1:length(fit_impostores_nueva),extension_ventana-inicioScores+1]<-fit_impostores_nueva
        }
      }  #fin de la tabla con la extensin de ventana desde inicio scores a fin scores
      
      if(nrow(scores_aut_usuario_rendimiento)>0 & nrow(scores_imp_usuario_rendimiento)>0){
        
        #-----> quito todas las filas que contienen NAns a travs de una secuencia de valores igualmente espaciados
        minimo_numero_scores_columnas<-min(colSums(!is.na(scores_aut_usuario_rendimiento)))
        columnas_a_modificar<-which(colSums(!is.na(scores_aut_usuario_rendimiento))!=minimo_numero_scores_columnas)
        columnas_no_modificar<-which(colSums(!is.na(scores_aut_usuario_rendimiento))==minimo_numero_scores_columnas)
        
        scores_autenticos_limpios<-data.frame(NULL,NULL,NULL)
        for(columna_score_aut in 1:ncol(scores_aut_usuario_rendimiento)){
          if( length(setdiff(columna_score_aut, columnas_no_modificar)) ==0 ){
            #se deja tal cual, no se modifica
            scores_autenticos_limpios[1:length(scores_aut_usuario_rendimiento[!is.na(scores_aut_usuario_rendimiento[,columna_score_aut]),columna_score_aut]),columna_score_aut]<-scores_aut_usuario_rendimiento[!is.na(scores_aut_usuario_rendimiento[,columna_score_aut]),columna_score_aut]
          }else{
            #se modifica
            posiciones<-round(seq(1,length(scores_aut_usuario_rendimiento[!is.na(scores_aut_usuario_rendimiento[,columna_score_aut]),columna_score_aut]), length.out = minimo_numero_scores_columnas))
            valores_a_poner<-scores_aut_usuario_rendimiento[posiciones,columna_score_aut]
            scores_autenticos_limpios[1:length(valores_a_poner),columna_score_aut]<-valores_a_poner
          }
        }
        
        minimo_numero_scores_columnas_imp<-min(colSums(!is.na(scores_imp_usuario_rendimiento)))
        columnas_a_modificar_imp<-which(colSums(!is.na(scores_imp_usuario_rendimiento))!=minimo_numero_scores_columnas_imp)
        columnas_no_modificar_imp<-which(colSums(!is.na(scores_imp_usuario_rendimiento))==minimo_numero_scores_columnas_imp)
        
        scores_impostores_limpios<-data.frame(NULL,NULL,NULL)
        for(columna_score_imp in 1:ncol(scores_imp_usuario_rendimiento)){
          if( length(setdiff(columna_score_imp, columnas_no_modificar_imp)) == 0 ){
            #se deja tal cual, no se modifica
            scores_impostores_limpios[1:length(scores_imp_usuario_rendimiento[!is.na(scores_imp_usuario_rendimiento[,columna_score_imp]),columna_score_imp]),columna_score_imp]<-scores_imp_usuario_rendimiento[!is.na(scores_imp_usuario_rendimiento[,columna_score_imp]),columna_score_imp]
          }else{
            #se modifica
            posiciones<-round(seq(1,length(scores_imp_usuario_rendimiento[!is.na(scores_imp_usuario_rendimiento[,columna_score_imp]),columna_score_imp]), length.out = minimo_numero_scores_columnas_imp))
            valores_a_poner<-scores_imp_usuario_rendimiento[posiciones,columna_score_imp]
            scores_impostores_limpios[1:length(valores_a_poner),columna_score_imp]<-valores_a_poner
          }
        }
        
        if(est_scores=="media"){
          #----> apply 1 es por filas
          scores_autenticos<-apply(scores_autenticos_limpios, 1, mean)
          scores_impostores<-apply(scores_impostores_limpios, 1, mean)
        }else if(est_scores=="mediana"){
          scores_autenticos<-apply(scores_autenticos_limpios, 1, median)
          scores_impostores<-apply(scores_impostores_limpios, 1, median)
        }else if(est_scores=="minimo"){
          scores_autenticos<-apply(scores_autenticos_limpios, 1, min)
          scores_impostores<-apply(scores_impostores_limpios, 1, min)
        }else if(est_scores=="maximo"){
          scores_autenticos<-apply(scores_autenticos_limpios, 1, max)
          scores_impostores<-apply(scores_impostores_limpios, 1, max)
        }
        
        curva_ROC<-roc.curve(scores_impostores, scores_autenticos, curve=TRUE)
        datos_tasa_eer<-curva_ROC$curve
        tasa_equierror<-eer(pfa=datos_tasa_eer[,1], pmiss=1-datos_tasa_eer[,2])
        
        if(tasa_equierror==0.5){
          tasa_equierror<-1
        }
        
        tabla_final_EER[which(n_caracteristicas==k),which(usuarios_utilizar==user)]<-tasa_equierror
      }
      
      cat("Fin del usuario ",user," con ",k,"caractersticas\n")
    }  #fin del k in n_caracteristicas
    cat("Fin del usuario",user,"\n")
  }
  colnames(tabla_final_EER)<-usuarios_utilizar
  rownames(tabla_final_EER)<-n_caracteristicas
  
  write.csv2(tabla_final_EER, file=paste("EER_Kcaract_usersJuntos_",dominio,"_RELIEF_Fusion_",est_scores,".csv",sep=""))
}

## Llamadas a la funcin principal para los casos de inters
#----> Dominio del tiempo
obtener_tabla_VariarNCaracteristicas(umbral = "2_4", ruta_inicio_auxiliar = "C:/Users/Irene Salvador/Desktop/QUINTO CURSO/---------- TFG/RendimientoFinal_seq/",
                                     dominio = "DT_X", experimental = "MonoMono", k_knn = 1, dispositivo = "Micro", tipo = "ACC", extension_ventana_EC = 8, solapamiento = 20, inicioScores = 6, finScores = 10, numVentanas = 4, solapamientoVent = 2, est_scores = "media")
obtener_tabla_VariarNCaracteristicas(umbral = "2_4", ruta_inicio_auxiliar = "C:/Users/Irene Salvador/Desktop/QUINTO CURSO/---------- TFG/RendimientoFinal_seq/",
                                     dominio = "DT_Y", experimental = "MonoMono", k_knn = 1, dispositivo = "Micro", tipo = "ACC", extension_ventana_EC = 8, solapamiento = 20, inicioScores = 6, finScores = 10, numVentanas = 4, solapamientoVent = 2, est_scores = "media")
obtener_tabla_VariarNCaracteristicas(umbral = "2_4", ruta_inicio_auxiliar = "C:/Users/Irene Salvador/Desktop/QUINTO CURSO/---------- TFG/RendimientoFinal_seq/",
                                     dominio = "DT_Z", experimental = "MonoMono", k_knn = 1, dispositivo = "Micro", tipo = "ACC", extension_ventana_EC = 8, solapamiento = 20, inicioScores = 6, finScores = 10, numVentanas = 4, solapamientoVent = 2, est_scores = "media")
obtener_tabla_VariarNCaracteristicas(umbral = "2_4", ruta_inicio_auxiliar = "C:/Users/Irene Salvador/Desktop/QUINTO CURSO/---------- TFG/RendimientoFinal_seq/",
                                     dominio = "modulo_DT", experimental = "MonoMono", k_knn = 1, dispositivo = "Micro", tipo = "ACC", extension_ventana_EC = 8, solapamiento = 20, inicioScores = 6, finScores = 10, numVentanas = 4, solapamientoVent = 2, est_scores = "media")

#----> Dominio de la frecuencia
obtener_tabla_VariarNCaracteristicas(umbral = "2_4", ruta_inicio_auxiliar = "C:/Users/Irene Salvador/Desktop/QUINTO CURSO/---------- TFG/RendimientoFinal_seq/",
                                     dominio = "DF_X", experimental = "MonoMono", k_knn = 1, dispositivo = "Micro", tipo = "ACC", extension_ventana_EC = 8, solapamiento = 20, inicioScores = 6, finScores = 10, numVentanas = 4, solapamientoVent = 2, est_scores = "media")
obtener_tabla_VariarNCaracteristicas(umbral = "2_4", ruta_inicio_auxiliar = "C:/Users/Irene Salvador/Desktop/QUINTO CURSO/---------- TFG/RendimientoFinal_seq/",
                                     dominio = "DF_Y", experimental = "MonoMono", k_knn = 1, dispositivo = "Micro", tipo = "ACC", extension_ventana_EC = 8, solapamiento = 20, inicioScores = 6, finScores = 10, numVentanas = 4, solapamientoVent = 2, est_scores = "media")
obtener_tabla_VariarNCaracteristicas(umbral = "2_4", ruta_inicio_auxiliar = "C:/Users/Irene Salvador/Desktop/QUINTO CURSO/---------- TFG/RendimientoFinal_seq/",
                                     dominio = "DF_Z", experimental = "MonoMono", k_knn = 1, dispositivo = "Micro", tipo = "ACC", extension_ventana_EC = 8, solapamiento = 20, inicioScores = 6, finScores = 10, numVentanas = 4, solapamientoVent = 2, est_scores = "media")
obtener_tabla_VariarNCaracteristicas(umbral = "2_4", ruta_inicio_auxiliar = "C:/Users/Irene Salvador/Desktop/QUINTO CURSO/---------- TFG/RendimientoFinal_seq/",
                                     dominio = "modulo_DF", experimental = "MonoMono", k_knn = 1, dispositivo = "Micro", tipo = "ACC", extension_ventana_EC = 8, solapamiento = 20, inicioScores = 6, finScores = 10, numVentanas = 4, solapamientoVent = 2, est_scores = "media")

########## Grficos variando el valor de K en cada usuario

#1) Lectura de la tabla que contiene la informacion
dispositivo<-"Micro"
tipo<-"ACC"
experimental<-"MonoMono"
dominio<-"modulo_DF"
#EER_Kcaract_DT_X_RELIEF_Fusion_media.csv
tabla_EER_caract<-read.csv2(file=paste("C:/Users/Irene Salvador/Desktop/QUINTO CURSO/---------- TFG/RendimientoFinal_seq/SeleccionCaracter/",dispositivo,tipo,"/",experimental,"/",dominio,"/umbralVariable/EER_Kcaract_usersJuntos_",dominio,"_RELIEF_Fusion_media.csv",sep=""), header=TRUE, dec=",", sep=";") 
tabla_EER_caract<-tabla_EER_caract[,2:(ncol(tabla_EER_caract)-1)]
colnames(tabla_EER_caract)<-paste("usuario",as.numeric(substring(colnames(tabla_EER_caract), 2, nchar(colnames(tabla_EER_caract)))),sep="")
#tabla_EER_caract[,"usuario3"]<-as.numeric(gsub(",",".",tabla_EER_caract[,"usuario3"]))

rownames(tabla_EER_caract)<-seq(1,nrow(tabla_EER_caract),by=1)

df<-as.data.frame(t(tabla_EER_caract))

df$row.names<-rownames(df)
long.df<-melt(df,id=c("row.names")) #se divide la tabla, en row.names/variable/value -> usuario, k, EER
colnames(long.df)<-c("usuario","num_caracteristicas","EER")
long.df$EER<-round(as.numeric(long.df$EER), digits=5)
pdf(file = paste("C:/Users/Irene Salvador/Desktop/QUINTO CURSO/---------- TFG/RendimientoFinal_seq/SeleccionCaracter/",dispositivo,tipo,"/",experimental,"/Graficos/",dominio,"_numVariablesVSEER_userJuntos_RELIEF.pdf",sep=""), family = "Helvetica",width = 10)
myplot2<-ggplot(long.df,aes(x=num_caracteristicas,y=EER,color=usuario, group=usuario, label=num_caracteristicas))+geom_line()+geom_point(pch=19, cex=2)+facet_wrap(~ usuario)+geom_text(aes(label=num_caracteristicas),hjust=0.5, vjust=-0.5)+ggtitle(paste("EER vs nmero de caractersticas por usuario (",dominio,")",sep=""))+ylim(0,1)
print(myplot2)
dev.off()
